Nuvei (formerly SafeCharge) gateway guide
Quick Start
New to integrating Nuvei with Spreedly? Here's your setup guide:
- Retrieve your Nuvei credentials
- Contact the Nuvei support team to obtain API credentials
- Get familiar with the Spreedly API
- Review Spreedly API basics
- Understand the core concepts: Gateways, Payment Methods, and Transactions
- Add Nuvei gateway to Spreedly in sandbox mode
Review this documentation to understand more about how to test transactions.
Adding a Nuvei Gateway
Required Credentials
- login_id: Your Nuvei login_id
- passcode: Your Nuvei password
Request:
curl https://core.spreedly.com/v1/gateways.xml \
-u 'C7cRfNJGODKh4Iu5Ox3PToKjniY:4UIuWybmdythfNGPqAqyQnYha6s451ri0fYAo4p3drZUi7q2Jf4b7HKg8etDtoKJ' \
-H 'Content-Type: application/xml' \
-d '<gateway>
<gateway_type>safe_charge</gateway_type>
<client_login_id>Your login</client_login_id>
<client_password>Your password</client_password>
</gateway>'Response:
<gateway>
<token>R3WBT9usBm6nCITJKfwGkbWx9fw</token>
<gateway_type>safe_charge</gateway_type>
<name>SafeCharge</name>
<description nil="true"/>
<client_login_id>Your login</client_login_id>
<characteristics>
<supports_purchase type="boolean">true</supports_purchase>
<supports_authorize type="boolean">true</supports_authorize>
<supports_capture type="boolean">true</supports_capture>
<supports_credit type="boolean">true</supports_credit>
<supports_general_credit type="boolean">true</supports_general_credit>
<supports_void type="boolean">true</supports_void>
<supports_verify type="boolean">true</supports_verify>
<supports_reference_purchase type="boolean">true</supports_reference_purchase>
<supports_purchase_via_preauthorization type="boolean">false</supports_purchase_via_preauthorization>
<supports_offsite_purchase type="boolean">false</supports_offsite_purchase>
<supports_offsite_authorize type="boolean">false</supports_offsite_authorize>
<supports_3dsecure_purchase type="boolean">true</supports_3dsecure_purchase>
<supports_3dsecure_authorize type="boolean">false</supports_3dsecure_authorize>
<supports_store type="boolean">false</supports_store>
<supports_remove type="boolean">false</supports_remove>
<supports_fraud_review type="boolean">false</supports_fraud_review>
<supports_disburse type="boolean">false</supports_disburse>
</characteristics>
<credentials>
<credential>
<name>client_login_id</name>
<value>Your login</value>
</credential>
</credentials>
<gateway_specific_fields>
<gateway_specific_field>user_id</gateway_specific_field>
<gateway_specific_field>auth_type</gateway_specific_field>
<gateway_specific_field>expected_fulfillment_count</gateway_specific_field>
<gateway_specific_field>website_id</gateway_specific_field>
<gateway_specific_field>vendor_id</gateway_specific_field>
<gateway_specific_field>merchant_descriptor</gateway_specific_field>
<gateway_specific_field>merchant_phone_number</gateway_specific_field>
<gateway_specific_field>merchant_name</gateway_specific_field>
<gateway_specific_field>stored_credential_mode</gateway_specific_field>
</gateway_specific_fields>
<payment_methods>
<payment_method>credit_card</payment_method>
</payment_methods>
<state>retained</state>
<redacted type="boolean">false</redacted>
<created_at type="dateTime">2018-06-19T17:07:35Z</created_at>
<updated_at type="dateTime">2018-06-19T17:07:35Z</updated_at>
</gateway>Purchase (Auth and Capture)
Request
curl https://core.spreedly.com/v1/gateways/LlkjmEk0xNkcWrNixXa1fvNoTP4/purchase.xml \
-u 'C7cRfNJGODKh4Iu5Ox3PToKjniY:4UIuWybmdythfNGPqAqyQnYha6s451ri0fYAo4p3drZUi7q2Jf4b7HKg8etDtoKJ' \
-H 'Content-Type: application/xml' \
-d '<transaction>
<payment_method_token>56wyNnSmuA6CWYP7w0MiYCVIbW6</payment_method_token>
<amount>100</amount>
<currency_code>USD</currency_code>
</transaction>'<transaction>
<on_test_gateway type="boolean">true</on_test_gateway>
<created_at type="dateTime">2023-07-26T22:44:00Z</created_at>
<updated_at type="dateTime">2023-07-26T22:44:00Z</updated_at>
<succeeded type="boolean">true</succeeded>
<state>succeeded</state>
<token>YwpCljQ1t7NolQ5rp6fhtkvEXYH</token>
<transaction_type>Purchase</transaction_type>
<order_id nil="true"/>
<ip nil="true"/>
<description nil="true"/>
<email nil="true"/>
<merchant_name_descriptor nil="true"/>
<merchant_location_descriptor nil="true"/>
<merchant_profile_key nil="true"/>
<gateway_specific_fields>
<safe_charge>
<user_id>123</user_id>
<auth_type>1</auth_type>
<expected_fulfillment_count>12</expected_fulfillment_count>
<merchant_descriptor>Descriptor</merchant_descriptor>
<merchant_phone_number>(555)555-5555</merchant_phone_number>
<merchant_name>Merchant</merchant_name>
<stored_credential_mode>true</stored_credential_mode>
<is_partial_approval>true</is_partial_approval>
<product_id>Product</product_id>
<not_use_cvv>true</not_use_cvv>
<unreferenced_refund>true</unreferenced_refund>
<middle_name>name</middle_name>
<card_holder_verification>1</card_holder_verification>
</safe_charge>
</gateway_specific_fields>
<gateway_specific_response_fields>
</gateway_specific_response_fields>
<gateway_transaction_id>54</gateway_transaction_id>
<sub_merchant_key nil="true"/>
<gateway_latency_ms type="integer">1</gateway_latency_ms>
<warning nil="true"/>
<application_id nil="true"/>
<amount type="integer">100</amount>
<local_amount nil="true"/>
<currency_code>USD</currency_code>
<retain_on_success type="boolean">false</retain_on_success>
<payment_method_added type="boolean">false</payment_method_added>
<smart_routed type="boolean">false</smart_routed>
<stored_credential_initiator nil="true"/>
<stored_credential_reason_type nil="true"/>
<stored_credential_gateway_override nil="true"/>
<populate_mit_fields type="boolean">false</populate_mit_fields>
<message key="messages.transaction_succeeded">Succeeded!</message>
<gateway_token>T11bJAANtTWnxl36GYjKWvbNK0g</gateway_token>
<gateway_type>test</gateway_type>
<shipping_address>
<name>Newfirst Newlast</name>
<address1 nil="true"/>
<address2 nil="true"/>
<city nil="true"/>
<state nil="true"/>
<zip nil="true"/>
<country nil="true"/>
<phone_number nil="true"/>
</shipping_address>
<response>
<success type="boolean">true</success>
<message>Successful purchase</message>
<avs_code nil="true"/>
<avs_message nil="true"/>
<cvv_code nil="true"/>
<cvv_message nil="true"/>
<pending type="boolean">false</pending>
<result_unknown type="boolean">false</result_unknown>
<error_code nil="true"/>
<error_detail nil="true"/>
<cancelled type="boolean">false</cancelled>
<fraud_review nil="true"/>
<created_at type="dateTime">2023-07-26T22:44:00Z</created_at>
<updated_at type="dateTime">2023-07-26T22:44:00Z</updated_at>
</response>
<api_urls>
</api_urls>
<payment_method>
<token>1rpKvP8zOUhj4Y9EDrIoIYQzzD5</token>
<created_at type="dateTime">2017-06-26T17:04:38Z</created_at>
<updated_at type="dateTime">2023-07-19T16:09:17Z</updated_at>
<email>[email protected]</email>
<data>
<my_payment_method_identifier>448</my_payment_method_identifier>
<extra_stuff>
<some_other_things>Can be anything really</some_other_things>
</extra_stuff>
</data>
<storage_state>retained</storage_state>
<test type="boolean">true</test>
<metadata>
<key>string value</key>
</metadata>
<callback_url nil="true"/>
<last_four_digits>1111</last_four_digits>
<first_six_digits>411111</first_six_digits>
<card_type>visa</card_type>
<first_name>Newfirst</first_name>
<last_name>Newlast</last_name>
<month type="integer">3</month>
<year type="integer">2032</year>
<address1 nil="true"/>
<address2 nil="true"/>
<city nil="true"/>
<state nil="true"/>
<zip nil="true"/>
<country nil="true"/>
<phone_number nil="true"/>
<company nil="true"/>
<full_name>Newfirst Newlast</full_name>
<eligible_for_card_updater type="boolean">true</eligible_for_card_updater>
<shipping_address1 nil="true"/>
<shipping_address2 nil="true"/>
<shipping_city nil="true"/>
<shipping_state nil="true"/>
<shipping_zip nil="true"/>
<shipping_country nil="true"/>
<shipping_phone_number nil="true"/>
<issuer_identification_number nil="true"/>
<click_to_pay type="boolean">false</click_to_pay>
<managed nil="true"/>
<payment_method_type>credit_card</payment_method_type>
<errors>
</errors>
<verification_value></verification_value>
<number>XXXX-XXXX-XXXX-1111</number>
<fingerprint>e3cef43464fc832f6e04f187df25af497994</fingerprint>
<stored_credential_usage>
<test>
<original_network_transaction_id>37be5367d6dbe4a88c9d</original_network_transaction_id>
<network_transaction_id>37be5367d6dbe4a88c9d</network_transaction_id>
</test>
</stored_credential_usage>
</payment_method>
<attempt_3dsecure type="boolean">false</attempt_3dsecure>
</transaction>Advanced features
Third-party 3DS2 auth data
Spreedly will automatically handle the field mapping for sending third-party 3DS2 authentication data to Nuvei. For more information about how to use this feature, see the 3DS2 Third-party Authentication guide. Spreedly fields map to the relevant Nuvei fields as described in the following table. Note that the challenge_preference field is being set to NoPreference since exemptions are not supported.
| Field Name | Type | Nuvei Field |
|---|---|---|
three_ds_version | String | threeDSProtocolVersion |
ecommerce_indicator | String | eci |
authentication_value | String | cavv |
directory_server_transaction_id | String | dsTransID |
xid | String | xid |
challenge_preference | String | challengePreference |
Gateway Specific Fields
<gateway_specific_fields>
<safe_charge>
<user_id>123</user_id>
<auth_type>1</auth_type>
<expected_fulfillment_count>12</expected_fulfillment_count>
<merchant_descriptor>Descriptor</merchant_descriptor>
<merchant_phone_number>(555)555-5555</merchant_phone_number>
<merchant_name>Merchant</merchant_name>
<stored_credential_mode>true</stored_credential_mode>
<is_partial_approval>true</is_partial_approval>
<product_id>Product</product_id>
<not_use_cvv>true</not_use_cvv>
<unreferenced_refund>true</unreferenced_refund>
<middle_name>name</middle_name>
<card_holder_verification>1</card_holder_verification>
</safe_charge>
</gateway_specific_fields>- When making a transaction, you can specify
user_id; this maps to the gateway’sUserIDfield. - When making an authorize call you can specify
auth_typeandexpected_fulfillment_count; these parameters map tosg_AuthType(to trigger the pre-authorization transaction type) andsg_ExpectedFulfillmentCountrespectively. - When making any call, you may specify
website_id,vendor_id,product_id,middle_name, andcard_holder_verificationwhich correspond tosg_WebsiteID,sg_VendorID,sg_ProductID,sg_middleName, andsg_doCardHolderNameVerificationrespectively. - When making a purchase, authorize, or credit you can specify
stored_credential_modeastrueorfalse. When specified astrue, the transaction will be flagged as completed using a previously tokenized and stored card data. Specifyfalsewhen the card data was entered for the first time, which will be tokenized and stored for future transactions. - When making any call, you may specify
merchant_descriptor,merchant_phone_number, andmerchant_name. These fields are part of Nuvei’s Dynamic Descriptor service and may used to display information on a customer’s credit card statement. - When attempting a credit, you may specify
unreferenced_refundfield as atruevalue if you wish to have an unreferenced refund.
| Field Name | Type | Required | Use Case (Description) | Example Value |
|---|---|---|---|---|
user_id | String | No | UserId Field | example_user_id |
auth_type | String | No | To trigger Preauthorization transaction type | 1 |
sg_ExpectedFulfillmentCount | String | No | Maps to sg_ExpectedFulfillmentCountfield at the gateway | 12 |
website_id | String | No | Maps to website_id field for the gateway | [email protected] |
vendor_id | Boolean | No | Maps to vendor_id field for the gateway | temp_id |
product_id | String | No | Maps to product_id field for the gateway | product |
middle_name | String | No | Maps to middle_name field for the gateway | abc123xyz |
merchant_descriptor | Boolean | No | This field is part of Nuvei’s Dynamic Descriptor service and may used to display information on a customer’s credit card statement | Descriptor |
merchant_phone_number | String | No | This field is part of Nuvei’s Dynamic Descriptor service and may used to display information on a customer’s credit card statement | 555)555-5555 |
merchant_name | String | No | This field is part of Nuvei’s Dynamic Descriptor service and may used to display information on a customer’s credit card statement | Merchant |
stored_credential_mode | Boolean | No | When specified as true, the transaction will be flagged as completed using a previously tokenized and stored card data. Specify false when the card data was entered for the first time, which will be tokenized and stored for future transactions. | true |
unreferenced_refund | Boolean | No | You may specify unreferenced_refund field as a true value if you wish to have an unreferenced refund | false |
Gateway Specific Response Fields
<transaction>
<token>LgpTNGjsWQs9DwdxcbreUVz0R8p</token>
<transaction_type>Purchase</transaction_type>
<gateway_specific_response_fields>
<safe_charge>
<card_type>Debit</card_type>
<auth_code>123</auth_code>
</safe_charge>
</gateway_specific_response_fields>
</transaction>| Field Name | Type | Description |
|---|---|---|
| card_type | string | Card type used in the transaction |
| auth_code | string | Authorization code returned by the Nuvei gateway indicating the result of the transaction. |
Stored Credentials
Spreedly supports the Stored Credential framework for Nuvei (formerly SafeCharge). For any Authorize or Purchase request, you need to include the below two fields which tell Spreedly a little bit more about the nature of the transaction.
stored_credential_initiatorstored_credential_reason_type
Learn more about how Spreedly enables use of stored credentials by reviewing our Stored Credentials guide
First / credential-on-file setup (CIT)
reason_type | initiator | card_on_file.type |
|---|---|---|
installment | cardholder | first_installment |
recurring | cardholder | first_recurring |
unscheduled | cardholder | first_unscheduled |
Additional resources
If you need support with this gateway, please contact Support at [email protected].
- Nuvei documentation: Reference
- API Endpoint: https://process.safecharge.com/service.asmx/Process (Production)
- Test Endpoint: https://process.sandbox.safecharge.com/service.asmx/Process (Test)

